!#************************************************************************
!# E.S.O. - 3.60 Upgrade Project
!#
!# who		when		what
!# ----------	--------	------------------------
!# p.Lesaux	?/?/?		created
!# p.leisy	06/08/1998	VLT Software adaptation
!# p.leisy	26/01/2000	Cuts (now really interactive)
!# p.leisy	26/01/2000	Angle now from 175 to 365 (allows small angles near limits)
!# p.leisy	26/01/2000	MosAlignement (mask slit only asked once !)
!# msterzik     05/10/00        statloop restricted to 10 iterations
!# rathreya	001223 		This prog used to auto-calculate the cuts and
!#				redisplay the MOS field image thus losing the
!#				previous display with the desired cuts using
!#				LoadImage. I have commented out the auto-
!#				calculation of cuts as well as the load/ima
!#				commands.
!# kbanse	100111		implement verifications
!# kbanse	100407		last modif
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!#   NAME:	Mosalign 
!# 
!#   SYNOPSIS:	Mosalign StarFRAME MosFRAME Angle
!#   
!#   DESCRIPTION:	
!#   Computes the Offsets to be applied to the Telescope to
!#   align the MOS plate with a star field.
!#    
!#   FILES:	
!#
!#   ENVIRONMENT:	
!#   PCO must be running together with a background MIDAS session	
!#
!#   RETURN VALUES:
!#   Offset in Alpha is written in the keyword OUTPUTR(1)
!#   Offset in Delta is written in the keyword OUTPUTR(2)
!#   Offset in Rotation is written in the keyword OUTPUTR(3)
!#
!#------------------------------------------------------------------------
!  Introduced a -1 factor for the angle to have the right sign!!!
!
!p1 ---> mos# : file containing starplate image
!p2 ---> file#: file with sky image
!p3 ---> angle: adapter angle
!p4 ---> flag: centering of the Slit frame
!
!
def/par P1 ? IMA "Enter MOS plate frame : "
def/par P2 ? IMA "Enter Sky image frame : "
def/par P3 0 N " Rotator angle [0] :"
def/par P5 0 N " low cut  :"
def/par P6 0 N " high cut :"

!*******************************************
!********************************************
! Instea of a FLAG ... could be to check the
! existence of the MIDAS table MOSPLA 
!********************************************
def/par P4 1   N " Alignment flag :"
!********************************************
!
! *******************************************
! EFOSC2 values for the CCD center (mean of 7 measurements) (1009.0,978.6)
!def/loc dx/r/1/1 -15.0	! complement to (1024,1024)
!def/loc dy/r/1/1 -45.4
def/loc dx/r/1/1 0
def/loc dy/r/1/1 0
! *******************************************

! keywords test and i will be used later on via @@ kcompare 
! in a lower level procedure, so we need to make them also known 
! at that lower procedure level...
define/local test/I/1/2 {P4} ? +lower 
define/local i/i/1/1	0 ? +lower
def/loc ra/r/1/1	0.0
def/loc dec/r/1/1	0.0
def/loc ang/r/1/1	0.0
def/loc rad/r/1/1	0.0
def/loc rotang/r/1/1	0.0
def/loc apoffset/r/1/1	0.0
def/loc sin/r/1/1	0.0
def/loc cos/r/1/1	0.0
def/loc xcon/r/1/1	0.0
def/loc ycon/r/1/1	0.0

indisk/fits {P1}  imaMOS
indisk/fits {P2}  imaOBJ

defi/loc Xmin/r/1/1	{imaMOS,START(1)}
defi/loc Ymin/r/1/1	{imaMOS,START(2)}
defi/loc stepX/r/1/1	{imaMOS,NPIX(1)}
defi/loc stepY/r/1/1	{imaMOS,NPIX(2)}
defi/loc binX/r/1/1	{imaMOS,STEP(1)}
defi/loc binY/r/1/1	{imaMOS,STEP(2)}
defi/loc Xmax/r/1/1	0
defi/loc Ymax/r/1/1	0
Xmax = {Xmin} + ({stepX}-1)*{binX}
Ymax = {Ymin} + ({stepY}-1)*{binY}
defi/loc xl/r/1/1	0
defi/loc xh/r/1/1	0
defi/loc yl/r/1/1	0
defi/loc yh/r/1/1	0
!
xl = {Xmin} + 0.02 * {stepX}
xh = {Xmin} + 0.98 * {stepX}
yl = {Ymin} + 0.02 * {stepY}
yh = {Ymin} + 0.98 * {stepY}

outputr(1) = xl
outputr(2) = xh
outputr(3) = yl
outputr(4) = yh
write/keyw rcorr 2.26000E+01,1.01140E+03,2.26000E+01,1.01140E+03
@@ kcompare mosa010:rcorr outputr 1,4 0.001

! We suppose that the frames have SQUARE pixels
def/loc scaOBJ/I/1/1	-2
def/loc stepOBJ/R/1/1	{imaOBJ,STEP(1)}
IF stepOBJ .EQ. 1 THEN
  scaOBJ = -4
ENDIF
def/loc scaMOS/I/1/1	-2
def/loc stepMOS/R/1/1	{imaMOS,STEP(1)}
IF stepMOS .EQ. 1 THEN
  scaMOS = -4
ENDIF

! Scale size measured (in @c obsinit)
! EFOSC2
!def/loc scale/r/1/1	{imscale}  ! 0.160 (Pleisy 1/1998) or 0.157 (? 5/1998)
def/loc scale/r/1/1     0.12
crea/tab skyima 7 7
IF test .NE. 0 THEN
  crea/tab mospla 7 7
ENDIF
clea/cha over
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
start:
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
write/out " "
write/out "The Alignment flag is : {test} "
write/out " "
!
icorr(1) = 1
@@ kcompare mosa020:icorr test 1,1

!defi/loc cut/R/1/4	100,64000,0,0
defi/loc level/R/1/2	0.02,-0.02
defi/loc count/I/1/1	0
defi/loc sig/R/1/1	0
defi/loc stat/R/1/2	0
!
IF test .NE. 0 THEN
  write/out " "
  write/out " "
  write/out " Loading starplate image "
  write/out " "
  write/out " Mark the points in the same order "
  write/out " "
  write/out " "
  load/ima imaMOS scale={scaMOS} center=C
  center/moment {idimemc},mos mospla
! center/gauss cursor mospla   ! previous centering method (less accurate)
! center/moment cursor mospla
  comp/tab mospla :xcen = :xcen + {dx}
  comp/tab mospla :ycen = :ycen + {dy}
clear/ch ov
ENDIF  
!
read/tab mospla
!
load/ima imaMOS scale={scaMOS} center=C
clea/cha over
!
! Drawing circles ....
comp/tab mospla :xstart = :xcen-20
comp/tab mospla :xend = :xcen+20
comp/tab mospla :ystart = :ycen-20
comp/tab mospla :yend = :ycen+20
draw/circ mospla F p4=3

write/out " "
write/out " "
write/out " Loading the image "
write/out " "
write/out " Mark the objects for aligment ... always in the same order "
write/out " "
write/out " "
load/ima imaOBJ scale={scaOBJ} cuts={P5},{P6}
center/gauss {idimemc},sky skyima 
! center=C cuts={cut(1)},{cut(2)}
!center/gauss cursor skyima 
comp/tab skyima :xcen = :xcen + {dx}
comp/tab skyima :ycen = :ycen + {dy}
!sort/tab skyima :xcen
read/tab skyima
write/keyw dimT1/I/1/1	{skyima.tbl,TBLCONTR(4)}
icorr = 3
@@ kcompare mosa030:icorr dimT1 1,1

copy/tk skyima :xcen,:ycen,:xerr,:yerr,:xsig,:ysig,:xfwhm,:yfwhm @3 -
outputr/r/1/8
write/keyw rcorr -
1.90087988281250e+03,1.63548791503906e+03,1.4561e-01,8.5567e-02,4.8105,4.0603,1.1328e+01,9.5612

@@ kcompare mosa040:rcorr outputr 1,2 0.01
@@ kcompare mosa042:rcorr outputr 3,6 0.0001
@@ kcompare mosa044:rcorr outputr 7,8 0.001

write/key dimT2/I/1/1	{mospla.tbl,TBLCONTR(4)}
!
IF dimT1 .NE. dimT2 THEN
  write/out " "
  write/out " "
  write/out " You select {dimT2} slits in the mask "
  write/out " "
  write/out " But {dimT1} objects in the image "
  write/out " "
  write/out " Number of objects marked not equal ... try again "
  write/out " "
  GOTO start
ENDIF

log(4) = 0

align/ima skyima mospla

read/key transfrm
ang = {transfrm(1)}

write/keyw dcorr -0.10673866279578946,1.0,1.0,0.99999826472575104,-0.00186294001155928087,0.00186294001155928087,0.99999826472575104,52.6033405295702323,-5.46493922902876239
@@ kcompare mosa050:dcorr transfrm 1,1 0.000005 2,7 0.000001
@@ kcompare mosa051:dcorr transfrm 8,8 0.005 9,9 0.00005

xcon = {transfrm(8)}
ycon = {transfrm(9)}
 
comp/key rad = 3.141592654*{ang} / 180
comp/key apoffset = 57296*{rad}
comp/key sin = M$SIN({p3})
comp/key cos = M$COS({p3})

! EFOSC_2 rotation NTT
comp/key ra  =   -1 * scale*({xcon}*{cos} + {ycon}*{sin})
comp/key dec =   -1 * scale*({ycon}*{cos} - {xcon}*{sin})

outputr(1) = ang
outputr(2) = ra
outputr(3) = dec
write/keyw rcorr -0.11,-6.31,0.66 
@@ kcompare mosa060:rcorr outputr 1,3 0.005

log(4) = 0
write/out
set/format F7.2
write/out "ROTATOR ANGLE = " {ang}
write/out 
set/format F7.2
write/out
write/out "*****************************************************"
write/out   "Offsets:  RA = {ra} arcsecs     DEC = {dec} arcsecs"
write/out "*****************************************************"
write/out
! ****************************
! output for Templates
! ****************************
outputR(1) = {ra}
outputR(2) = {dec}
outputR(3) = {ang}

delete/key dimT1
delete/key dimT2



